// +FHDR------------------------------------------------------------
//                 Copyright (c) 2022 SmartLogic.
//                       ALL RIGHTS RESERVED
// -----------------------------------------------------------------
// Filename      : ucp_ape_main.c
// Author        : xianfeng.du
// Created On    : 2022-06-25
// Last Modified :
// -----------------------------------------------------------------
// Description:
//
//
// -FHDR------------------------------------------------------------

#include "ape_top.h"
#include "lib_debug_init.h"
#include "log_client.h"
#include "osp_init.h"

int32_t main(int32_t argc, char* argv[])
{
    int32_t core_id = 0;
    int32_t ret = 0;

    set_core_id();

    core_id = get_core_id();
    debug_write(DBG_DDR_COMMON_IDX(core_id, 0), PLATFORM_BUILD_DATA);

    soc_drv_init();

    ret = spu_lib_debug_init(core_id);
    debug_write(DBG_DDR_COMMON_IDX(core_id, 1), ret);

    spu_log_client_init();

    spu_drv_init();

    spu_msg_transfer_init();

    osp_start();

    return 0;
}

