﻿/**********************************************************************************************************************
*  Copyright (C), 2022-2026, SMARTLOGIC TECHNOLOGY LTD.
*  File Name: ecpri_driver.h
*  Create Date: 23/08/18
*  Description: eCPRI Driver Module Header File
*  Change History:
*      <author>      <time>      <version>   <desc>
*    1. ShangH      23/08/18        1.0       Build this module
**********************************************************************************************************************/

#ifndef _ECPRI_DRIVER_H_
#define _ECPRI_DRIVER_H_


/* -------------------------------------------------- <INC FILE> --------------------------------------------------- */
#include "ucp_js_subcrg.h"
#include "ucp_param.h"
#include "ecpri_pma.h"
#include "ecpri_roec.h"
#include "ecpri_switch.h"
#include "phy_para.h"

/* -------------------------------------------------- <MACRO DEF> -------------------------------------------------- */
/* operation result */
#ifndef SUCCESS
#define SUCCESS                                  0
#endif

#ifndef ERROR
#define ERROR                                    (-1)
#endif


/* -------------------------------------------------- <TYPE DEF> --------------------------------------------------- */


/* --------------------------------------------------- <DECLARE> --------------------------------------------------- */

void ecpri_init(uint8_t nOption);

void ecpri_cprimode_init();

extern void ecpri_init_ex(uint32_t ecpri_speed_sel);


#endif /* _ECPRI_DRIVER_H_ */

