﻿/**********************************************************************************************************************
*  Copyright (C), 2022-2026, SMARTLOGIC TECHNOLOGY LTD.
*  File Name: ecpri_roec.h
*  Create Date: 23/08/18
*  Description: eCPRI ROEC Module Header File
*  Change History:
*      <author>      <time>      <version>   <desc>
*    1. ShangH      23/08/18        1.0       Build this module
**********************************************************************************************************************/

#ifndef _ECPRI_ROEC_H_
#define _ECPRI_ROEC_H_


/* -------------------------------------------------- <INC FILE> --------------------------------------------------- */
#include "ucp_ecpri.h"
#include "ucp_param.h"
#include "ucp_utility.h"


/* -------------------------------------------------- <MACRO DEF> -------------------------------------------------- */
/* operation result */
#ifndef SUCCESS
#define SUCCESS                                  0
#endif

#ifndef ERROR
#define ERROR                                    (-1)
#endif

/* eCPRI buffer physical address */
#define ECPRI_BUF_PHY_ADDR                       0xAEE00000
/* eCPRI buffer length */
#define ECPRI_BUF_LEN                            0x04000000

/* 502 verify case define data */
#define OTHER_DES_ADDR                           0xAEE00000ul // 0xAEE00000ul // 0x09d00000ul
#define OTHER_DES_SIZE                           0x03E00000ul // 0x03F00000ul // 0x00100000ul


/* -------------------------------------------------- <TYPE DEF> --------------------------------------------------- */


/* --------------------------------------------------- <DECLARE> --------------------------------------------------- */
/* eCPRI ROEC init */
extern void ecpri_roec_init(void);


#endif /* _ECPRI_ROEC_H_ */

