﻿/**********************************************************************************************************************
*  Copyright (C), 2022-2026, SMARTLOGIC TECHNOLOGY LTD.
*  File Name: ecpri_roec.s.c
*  Create Date: 23/08/18
*  Description: eCPRI ROEC Module Source File
*  Change History: 
*      <author>      <time>      <version>   <desc>
*    1. ShangH      23/08/18        1.0       Build this module
**********************************************************************************************************************/


/* -------------------------------------------------- <INC FILE> --------------------------------------------------- */
#include "ecpri_roec.h"


/* --------------------------------------------------- <VAR DEF> --------------------------------------------------- */


/* -------------------------------------------------- <FUNC DEF> --------------------------------------------------- */
/**********************************************************************************************************************
*  Function: ecpri_roec_init
*  Description: eCPRI ROEC init
*  Input: 
*    <name>        <type>               <desc>
*     dev           net_device *         network device
*     data          uint8_t *            data received
*     len           uint32_t             data length
*  Output: none
*  Return: operation result - success or failure.
*  Others: none
**********************************************************************************************************************/
void ecpri_roec_init(void)
{
    do_write(&ROEC_ENABLE, BIT0);

    //配置收到包写入DDR里面
    do_write(&DESC_PTR_CNT_2, 4);
    do_write(&DESC_BEGIN_ADDR_2, (OTHER_DES_ADDR / 32));
    do_write(&DESC_END_ADDR_2, (OTHER_DES_ADDR / 32 + OTHER_DES_SIZE / 32));
    do_write(&DESC_SHIFT_2, 7);//16k
    do_write(&DESC_TAIL_ADDR_2, (OTHER_DES_ADDR / 32) + OTHER_DES_SIZE / 32);
    do_write(&DESC_START_2, 1);
}



