//******************** (C) COPYRIGHT 2020 SmartLogic*******************************
// FileName           : jesd204.h
// Author             : liugeng, geng.liu@smartlogictech.com
// Date First Issued  : 2022-06-01 06:16:38 PM
// Last Modified      : 2022-06-02 10:12:03 AM
// Description        :
// ------------------------------------------------------------
// Modification History:
// Version    Date       Author    Modification Description
//
//**********************************************************************************


//******************** (C) COPYRIGHT 2020 SmartLogic*******************************
#ifndef __JESD204_H__
#define __JESD204_H__

#include "typedef.h"

#define JS_CSU_BASE              0x05F60000
#define JS_COMC_BASE             0x06000000
#define JS_COMC_204B_RX0_BASE    JS_COMC_BASE + 0x0000
#define JS_COMC_204B_RX1_BASE    JS_COMC_BASE + 0x1000
#define JS_COMC_204B_TX_BASE     JS_COMC_BASE + 0x2000
#define JS_COMC_204C_RX0_BASE    JS_COMC_BASE + 0x3000
#define JS_COMC_204C_RX1_BASE    JS_COMC_BASE + 0x4000
#define JS_COMC_204C_TX_BASE     JS_COMC_BASE + 0x5000
//#define JS_RX0_TMR_BASE          JS_COMC_BASE + 0x6000
//#define JS_RX1_TMR_BASE          JS_COMC_BASE + 0x7000
//#define JS_TX0_TMR_BASE          JS_COMC_BASE + 0x8000
//#define JS_TX1_TMR_BASE          JS_COMC_BASE + 0x9000
#define JS_204B_RX0_SUBCTRL_BASE      0x06080000
#define JS_204C_RX0_SUBCTRL_BASE      0x06090000
#define JS_204B_RX1_SUBCTRL_BASE      0x060A0000
#define JS_204C_RX1_SUBCTRL_BASE      0x060B0000
#define JS_204B_TX_SUBCTRL_BASE       0x060C0000
#define JS_204C_TX_SUBCTRL_BASE       0x060D0000

#define JS_COMC_204B_RX0_BANK_ID                            (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x000)))
#define JS_COMC_204B_RX0_DID                                (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x004)))
#define JS_COMC_204B_RX0_LID                                (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x008)))
#define JS_COMC_204B_RX0_LID2                               (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x00C)))
#define JS_COMC_204B_RX0_LID3                               (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x010)))
#define JS_COMC_204B_RX0_LID4                               (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x014)))
#define JS_COMC_204B_RX0_DATAPATH_INTERCONNECT              (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x018)))
#define JS_COMC_204B_RX0_SUBCLASS                           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x01C)))
#define JS_COMC_204B_RX0_CF                                 (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x020)))
#define JS_COMC_204B_RX0_CS                                 (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x024)))
#define JS_COMC_204B_RX0_F                                  (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x028)))
#define JS_COMC_204B_RX0_K                                  (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x02C)))
#define JS_COMC_204B_RX0_L                                  (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x030)))
#define JS_COMC_204B_RX0_N                                  (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x034)))
#define JS_COMC_204B_RX0_M                                  (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x038)))
#define JS_COMC_204B_RX0_NTOTAL                             (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x03C)))
#define JS_COMC_204B_RX0_S                                  (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x040)))
#define JS_COMC_204B_RX0_HD                                 (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x044)))
#define JS_COMC_204B_RX0_SCR                                (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x048)))
#define JS_COMC_204B_RX0_ENABLEMODULE                       (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x050)))
#define JS_COMC_204B_RX0_ENABLELINKTEST                     (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x054)))
#define JS_COMC_204B_RX0_GEN_SYSREF                         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x3E4)))
#define JS_COMC_204B_RX0_FEC_EN                             (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2C4)))
#define JS_COMC_204B_RX0_CRC3_EN                            (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2C8)))
#define JS_COMC_204B_RX0_CRC12_EN                           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2CC)))
#define JS_COMC_204B_RX0_SOFT_SYNC                          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2D0)))
#define JS_COMC_204B_RX0_E                                  (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2D4)))
#define JS_COMC_204B_RX0_BIT_ORDER                          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2D8)))
#define JS_COMC_204B_RX0_TL_TEST_MODE                       (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2DC)))
#define JS_COMC_204B_RX0_RESYNC_COUNT_STATUS                (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2FC)))
#define JS_COMC_204B_RX0_S_ON_IF_REG                        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x368)))
//#define JS_COMC_204B_RX0_MERGE_CF_GROUP                   (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x36C)))
#define JS_COMC_204B_RX0_CMD_EN                             (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x370)))
#define JS_COMC_204B_RX0_SYSREF_COUNTER_STATUS              (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x374)))
#define JS_COMC_204B_RX0_LINKCONFIGURATIONERROR             (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x04C)))
#define JS_COMC_204B_RX0_LINKTEST_0_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x058)))
#define JS_COMC_204B_RX0_LINKTEST_1_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x05C)))
#define JS_COMC_204B_RX0_LINKTEST_2_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x060)))
#define JS_COMC_204B_RX0_LINKTEST_3_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x064)))
#define JS_COMC_204B_RX0_LINKTEST_4_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x068)))
#define JS_COMC_204B_RX0_LINKTEST_5_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x06C)))
#define JS_COMC_204B_RX0_LINKTEST_6_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x070)))
#define JS_COMC_204B_RX0_LINKTEST_7_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x074)))
#define JS_COMC_204B_RX0_LINKTEST_8_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x078)))
#define JS_COMC_204B_RX0_LINKTEST_9_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x07C)))
#define JS_COMC_204B_RX0_LINKTEST_10_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x080)))
#define JS_COMC_204B_RX0_LINKTEST_11_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x084)))
#define JS_COMC_204B_RX0_LINKTEST_12_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x088)))
#define JS_COMC_204B_RX0_LINKTEST_13_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x08C)))
#define JS_COMC_204B_RX0_LINKTEST_14_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x090)))
#define JS_COMC_204B_RX0_LINKTEST_15_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x094)))
#define JS_COMC_204B_RX0_LINKTEST_16_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x098)))
#define JS_COMC_204B_RX0_LINKTEST_17_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x09C)))
#define JS_COMC_204B_RX0_LINKTEST_18_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0A0)))
#define JS_COMC_204B_RX0_LINKTEST_19_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0A4)))
#define JS_COMC_204B_RX0_LINKTEST_20_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0A8)))
#define JS_COMC_204B_RX0_LINKTEST_21_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0AC)))
#define JS_COMC_204B_RX0_LINKTEST_22_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0B0)))
#define JS_COMC_204B_RX0_LINKTEST_23_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0B4)))
#define JS_COMC_204B_RX0_LINKTEST_0_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0C0)))
#define JS_COMC_204B_RX0_LINKTEST_1_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0C4)))
#define JS_COMC_204B_RX0_LINKTEST_2_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0C8)))
#define JS_COMC_204B_RX0_LINKTEST_3_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0CC)))
#define JS_COMC_204B_RX0_LINKTEST_4_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0D0)))
#define JS_COMC_204B_RX0_LINKTEST_5_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0D4)))
#define JS_COMC_204B_RX0_LINKTEST_6_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0D8)))
#define JS_COMC_204B_RX0_LINKTEST_7_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0DC)))
#define JS_COMC_204B_RX0_LINKTEST_8_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0E0)))
#define JS_COMC_204B_RX0_LINKTEST_9_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0E4)))
#define JS_COMC_204B_RX0_LINKTEST_10_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0E8)))
#define JS_COMC_204B_RX0_LINKTEST_11_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0EC)))
#define JS_COMC_204B_RX0_LINKTEST_12_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0F0)))
#define JS_COMC_204B_RX0_LINKTEST_13_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0F4)))
#define JS_COMC_204B_RX0_LINKTEST_14_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0F8)))
#define JS_COMC_204B_RX0_LINKTEST_15_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x0FC)))
#define JS_COMC_204B_RX0_LINKTEST_16_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x100)))
#define JS_COMC_204B_RX0_LINKTEST_17_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x104)))
#define JS_COMC_204B_RX0_LINKTEST_18_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x108)))
#define JS_COMC_204B_RX0_LINKTEST_19_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x10C)))
#define JS_COMC_204B_RX0_LINKTEST_20_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x110)))
#define JS_COMC_204B_RX0_LINKTEST_21_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x114)))
#define JS_COMC_204B_RX0_LINKTEST_22_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x118)))
#define JS_COMC_204B_RX0_LINKTEST_23_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x11C)))
#define JS_COMC_204B_RX0_FEATURE_DISABLE                    (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x120)))
#define JS_COMC_204B_RX0_CORE_INTERRUPT_MASK                (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x124)))
#define JS_COMC_204B_RX0_CORE_INTERRUPT_STATUS              (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x128)))
#define JS_COMC_204B_RX0_ILAS_DETAILS                       (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x12C)))
#define JS_COMC_204B_RX0_ERR_INJ_REQ                        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x130)))
#define JS_COMC_204B_RX0_CLK_RATIO                          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x13C)))
#define JS_COMC_204B_RX0_PRBS_TEST_0_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x140)))
#define JS_COMC_204B_RX0_PRBS_TEST_1_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x144)))
#define JS_COMC_204B_RX0_PRBS_TEST_2_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x148)))
#define JS_COMC_204B_RX0_PRBS_TEST_3_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x14C)))
#define JS_COMC_204B_RX0_PRBS_TEST_4_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x150)))
#define JS_COMC_204B_RX0_PRBS_TEST_5_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x154)))
#define JS_COMC_204B_RX0_PRBS_TEST_6_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x158)))
#define JS_COMC_204B_RX0_PRBS_TEST_7_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x15C)))
#define JS_COMC_204B_RX0_PRBS_TEST_8_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x160)))
#define JS_COMC_204B_RX0_PRBS_TEST_9_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x164)))
#define JS_COMC_204B_RX0_PRBS_TEST_10_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x168)))
#define JS_COMC_204B_RX0_PRBS_TEST_11_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x16C)))
#define JS_COMC_204B_RX0_PRBS_TEST_12_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x170)))
#define JS_COMC_204B_RX0_PRBS_TEST_13_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x174)))
#define JS_COMC_204B_RX0_PRBS_TEST_14_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x178)))
#define JS_COMC_204B_RX0_PRBS_TEST_15_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x17C)))
#define JS_COMC_204B_RX0_PRBS_TEST_16_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x180)))
#define JS_COMC_204B_RX0_PRBS_TEST_17_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x184)))
#define JS_COMC_204B_RX0_PRBS_TEST_18_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x188)))
#define JS_COMC_204B_RX0_PRBS_TEST_19_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x18C)))
#define JS_COMC_204B_RX0_PRBS_TEST_20_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x190)))
#define JS_COMC_204B_RX0_PRBS_TEST_21_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x194)))
#define JS_COMC_204B_RX0_PRBS_TEST_22_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x198)))
#define JS_COMC_204B_RX0_PRBS_TEST_23_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x19C)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_0_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1A0)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_1_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1A4)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_2_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1A8)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_3_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1AC)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_4_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1B0)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_5_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1B4)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_6_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1B8)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_7_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1BC)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_8_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1C0)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_9_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1C4)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_10_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1C8)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_11_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1CC)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_12_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1D0)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_13_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1D4)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_14_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1D8)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_15_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1DC)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_16_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1E0)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_17_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1E4)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_18_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1E8)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_19_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1EC)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_20_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1F0)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_21_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1F4)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_22_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1F8)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_23_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x1FC)))
#define JS_COMC_204B_RX0_PRBS_TEST_0_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x200)))
#define JS_COMC_204B_RX0_PRBS_TEST_1_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x204)))
#define JS_COMC_204B_RX0_PRBS_TEST_2_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x208)))
#define JS_COMC_204B_RX0_PRBS_TEST_3_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x20C)))
#define JS_COMC_204B_RX0_PRBS_TEST_4_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x210)))
#define JS_COMC_204B_RX0_PRBS_TEST_5_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x214)))
#define JS_COMC_204B_RX0_PRBS_TEST_6_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x218)))
#define JS_COMC_204B_RX0_PRBS_TEST_7_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x21C)))
#define JS_COMC_204B_RX0_PRBS_TEST_8_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x220)))
#define JS_COMC_204B_RX0_PRBS_TEST_9_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x224)))
#define JS_COMC_204B_RX0_PRBS_TEST_10_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x228)))
#define JS_COMC_204B_RX0_PRBS_TEST_11_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x22C)))
#define JS_COMC_204B_RX0_PRBS_TEST_12_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x230)))
#define JS_COMC_204B_RX0_PRBS_TEST_13_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x234)))
#define JS_COMC_204B_RX0_PRBS_TEST_14_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x238)))
#define JS_COMC_204B_RX0_PRBS_TEST_15_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x23C)))
#define JS_COMC_204B_RX0_PRBS_TEST_16_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x240)))
#define JS_COMC_204B_RX0_PRBS_TEST_17_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x244)))
#define JS_COMC_204B_RX0_PRBS_TEST_18_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x248)))
#define JS_COMC_204B_RX0_PRBS_TEST_19_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x24C)))
#define JS_COMC_204B_RX0_PRBS_TEST_20_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x250)))
#define JS_COMC_204B_RX0_PRBS_TEST_21_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x254)))
#define JS_COMC_204B_RX0_PRBS_TEST_22_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x258)))
#define JS_COMC_204B_RX0_PRBS_TEST_23_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x25C)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_0_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x260)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_1_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x264)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_2_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x268)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_3_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x26C)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_4_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x270)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_5_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x274)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_6_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x278)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_7_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x27C)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_8_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x280)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_9_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x284)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_10_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x288)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_11_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x28C)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_12_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x290)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_13_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x294)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_14_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x298)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_15_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x29C)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_16_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2A0)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_17_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2A4)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_18_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2A8)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_19_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2AC)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_20_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2B0)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_21_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2B4)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_22_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2B8)))
#define JS_COMC_204B_RX0_JTSPAT_TEST_23_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2BC)))
#define JS_COMC_204B_RX0_LMFC_LEMC_DELAY                    (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2E0)))
#define JS_COMC_204B_RX0_SYSREF_CONFIG                      (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2E4)))
#define JS_COMC_204B_RX0_MAST_INST                          (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2E8)))
#define JS_COMC_204B_RX0_SH_LOCK_STATUS                     (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2EC)))
#define JS_COMC_204B_RX0_SH_LOCK_LOSS_STATUS                (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2F0)))
#define JS_COMC_204B_RX0_EMB_LOCK_STATUS                    (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2F4)))
#define JS_COMC_204B_RX0_EMB_LOCK_LOSS_STATUS               (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x2F8)))
#define JS_COMC_204B_RX0_LEMC_BOUNDARY_PHASE                (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x3D8)))
#define JS_COMC_204B_RX0_RBD_LENGTH_OCTETS                  (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x3DC)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE0                 (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x300)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE1                 (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x304)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE2                 (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x308)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE3                 (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x30C)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE4                 (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x310)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE5                 (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x314)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE6                 (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x318)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE7                 (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x31C)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE8                 (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x320)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE9                 (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x324)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE10                (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x328)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE11                (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x32C)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE12                (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x330)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE13                (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x334)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE14                (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x338)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE15                (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x33C)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE16                (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x340)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE17                (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x344)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE18                (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x348)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE19                (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x34C)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE20                (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x350)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE21                (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x354)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE22                (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x358)))
#define JS_COMC_204B_RX0_ERROR_REPORT_LANE23                (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x35C)))
#define JS_COMC_204B_RX0_TRESH_EMB_ERR                      (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x360)))
#define JS_COMC_204B_RX0_TRESH_SH_ERR                       (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x364)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE0              (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x378)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE1              (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x37C)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE2              (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x380)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE3              (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x384)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE4              (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x388)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE5              (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x38C)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE6              (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x390)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE7              (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x394)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE8              (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x398)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE9              (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x39C)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE10             (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x3A0)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE11             (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x3A4)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE12             (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x3A8)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE13             (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x3AC)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE14             (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x3B0)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE15             (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x3B4)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE16             (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x3B8)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE17             (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x3BC)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE18             (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x3C0)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE19             (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x3C4)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE20             (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x3C8)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE21             (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x3CC)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE22             (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x3D0)))
#define JS_COMC_204B_RX0_ICOUNTER_REPORT_LANE23             (*((volatile uint32_t *)(JS_COMC_204B_RX0_BASE + 0x3D4)))

#define JS_COMC_204B_RX1_BANK_ID                            (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x000)))
#define JS_COMC_204B_RX1_DID                                (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x004)))
#define JS_COMC_204B_RX1_LID                                (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x008)))
#define JS_COMC_204B_RX1_LID2                               (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x00C)))
#define JS_COMC_204B_RX1_LID3                               (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x010)))
#define JS_COMC_204B_RX1_LID4                               (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x014)))
#define JS_COMC_204B_RX1_DATAPATH_INTERCONNECT              (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x018)))
#define JS_COMC_204B_RX1_SUBCLASS                           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x01C)))
#define JS_COMC_204B_RX1_CF                                 (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x020)))
#define JS_COMC_204B_RX1_CS                                 (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x024)))
#define JS_COMC_204B_RX1_F                                  (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x028)))
#define JS_COMC_204B_RX1_K                                  (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x02C)))
#define JS_COMC_204B_RX1_L                                  (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x030)))
#define JS_COMC_204B_RX1_N                                  (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x034)))
#define JS_COMC_204B_RX1_M                                  (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x038)))
#define JS_COMC_204B_RX1_NTOTAL                             (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x03C)))
#define JS_COMC_204B_RX1_S                                  (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x040)))
#define JS_COMC_204B_RX1_HD                                 (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x044)))
#define JS_COMC_204B_RX1_SCR                                (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x048)))
#define JS_COMC_204B_RX1_ENABLEMODULE                       (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x050)))
#define JS_COMC_204B_RX1_ENABLELINKTEST                     (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x054)))
#define JS_COMC_204B_RX1_GEN_SYSREF                         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x3E4)))
#define JS_COMC_204B_RX1_FEC_EN                             (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2C4)))
#define JS_COMC_204B_RX1_CRC3_EN                            (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2C8)))
#define JS_COMC_204B_RX1_CRC12_EN                           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2CC)))
#define JS_COMC_204B_RX1_SOFT_SYNC                          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2D0)))
#define JS_COMC_204B_RX1_E                                  (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2D4)))
#define JS_COMC_204B_RX1_BIT_ORDER                          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2D8)))
#define JS_COMC_204B_RX1_TL_TEST_MODE                       (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2DC)))
#define JS_COMC_204B_RX1_RESYNC_COUNT_STATUS                (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2FC)))
#define JS_COMC_204B_RX1_S_ON_IF_REG                        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x368)))
//#define JS_COMC_204B_RX1_MERGE_CF_GROUP                   (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x36C)))
#define JS_COMC_204B_RX1_CMD_EN                             (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x370)))
#define JS_COMC_204B_RX1_SYSREF_COUNTER_STATUS              (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x374)))
#define JS_COMC_204B_RX1_LINKCONFIGURATIONERROR             (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x04C)))
#define JS_COMC_204B_RX1_LINKTEST_0_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x058)))
#define JS_COMC_204B_RX1_LINKTEST_1_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x05C)))
#define JS_COMC_204B_RX1_LINKTEST_2_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x060)))
#define JS_COMC_204B_RX1_LINKTEST_3_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x064)))
#define JS_COMC_204B_RX1_LINKTEST_4_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x068)))
#define JS_COMC_204B_RX1_LINKTEST_5_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x06C)))
#define JS_COMC_204B_RX1_LINKTEST_6_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x070)))
#define JS_COMC_204B_RX1_LINKTEST_7_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x074)))
#define JS_COMC_204B_RX1_LINKTEST_8_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x078)))
#define JS_COMC_204B_RX1_LINKTEST_9_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x07C)))
#define JS_COMC_204B_RX1_LINKTEST_10_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x080)))
#define JS_COMC_204B_RX1_LINKTEST_11_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x084)))
#define JS_COMC_204B_RX1_LINKTEST_12_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x088)))
#define JS_COMC_204B_RX1_LINKTEST_13_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x08C)))
#define JS_COMC_204B_RX1_LINKTEST_14_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x090)))
#define JS_COMC_204B_RX1_LINKTEST_15_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x094)))
#define JS_COMC_204B_RX1_LINKTEST_16_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x098)))
#define JS_COMC_204B_RX1_LINKTEST_17_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x09C)))
#define JS_COMC_204B_RX1_LINKTEST_18_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0A0)))
#define JS_COMC_204B_RX1_LINKTEST_19_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0A4)))
#define JS_COMC_204B_RX1_LINKTEST_20_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0A8)))
#define JS_COMC_204B_RX1_LINKTEST_21_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0AC)))
#define JS_COMC_204B_RX1_LINKTEST_22_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0B0)))
#define JS_COMC_204B_RX1_LINKTEST_23_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0B4)))
#define JS_COMC_204B_RX1_LINKTEST_0_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0C0)))
#define JS_COMC_204B_RX1_LINKTEST_1_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0C4)))
#define JS_COMC_204B_RX1_LINKTEST_2_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0C8)))
#define JS_COMC_204B_RX1_LINKTEST_3_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0CC)))
#define JS_COMC_204B_RX1_LINKTEST_4_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0D0)))
#define JS_COMC_204B_RX1_LINKTEST_5_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0D4)))
#define JS_COMC_204B_RX1_LINKTEST_6_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0D8)))
#define JS_COMC_204B_RX1_LINKTEST_7_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0DC)))
#define JS_COMC_204B_RX1_LINKTEST_8_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0E0)))
#define JS_COMC_204B_RX1_LINKTEST_9_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0E4)))
#define JS_COMC_204B_RX1_LINKTEST_10_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0E8)))
#define JS_COMC_204B_RX1_LINKTEST_11_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0EC)))
#define JS_COMC_204B_RX1_LINKTEST_12_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0F0)))
#define JS_COMC_204B_RX1_LINKTEST_13_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0F4)))
#define JS_COMC_204B_RX1_LINKTEST_14_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0F8)))
#define JS_COMC_204B_RX1_LINKTEST_15_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x0FC)))
#define JS_COMC_204B_RX1_LINKTEST_16_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x100)))
#define JS_COMC_204B_RX1_LINKTEST_17_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x104)))
#define JS_COMC_204B_RX1_LINKTEST_18_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x108)))
#define JS_COMC_204B_RX1_LINKTEST_19_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x10C)))
#define JS_COMC_204B_RX1_LINKTEST_20_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x110)))
#define JS_COMC_204B_RX1_LINKTEST_21_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x114)))
#define JS_COMC_204B_RX1_LINKTEST_22_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x118)))
#define JS_COMC_204B_RX1_LINKTEST_23_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x11C)))
#define JS_COMC_204B_RX1_FEATURE_DISABLE                    (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x120)))
#define JS_COMC_204B_RX1_CORE_INTERRUPT_MASK                (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x124)))
#define JS_COMC_204B_RX1_CORE_INTERRUPT_STATUS              (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x128)))
#define JS_COMC_204B_RX1_ILAS_DETAILS                       (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x12C)))
#define JS_COMC_204B_RX1_ERR_INJ_REQ                        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x130)))
#define JS_COMC_204B_RX1_CLK_RATIO                          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x13C)))
#define JS_COMC_204B_RX1_PRBS_TEST_0_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x140)))
#define JS_COMC_204B_RX1_PRBS_TEST_1_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x144)))
#define JS_COMC_204B_RX1_PRBS_TEST_2_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x148)))
#define JS_COMC_204B_RX1_PRBS_TEST_3_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x14C)))
#define JS_COMC_204B_RX1_PRBS_TEST_4_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x150)))
#define JS_COMC_204B_RX1_PRBS_TEST_5_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x154)))
#define JS_COMC_204B_RX1_PRBS_TEST_6_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x158)))
#define JS_COMC_204B_RX1_PRBS_TEST_7_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x15C)))
#define JS_COMC_204B_RX1_PRBS_TEST_8_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x160)))
#define JS_COMC_204B_RX1_PRBS_TEST_9_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x164)))
#define JS_COMC_204B_RX1_PRBS_TEST_10_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x168)))
#define JS_COMC_204B_RX1_PRBS_TEST_11_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x16C)))
#define JS_COMC_204B_RX1_PRBS_TEST_12_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x170)))
#define JS_COMC_204B_RX1_PRBS_TEST_13_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x174)))
#define JS_COMC_204B_RX1_PRBS_TEST_14_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x178)))
#define JS_COMC_204B_RX1_PRBS_TEST_15_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x17C)))
#define JS_COMC_204B_RX1_PRBS_TEST_16_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x180)))
#define JS_COMC_204B_RX1_PRBS_TEST_17_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x184)))
#define JS_COMC_204B_RX1_PRBS_TEST_18_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x188)))
#define JS_COMC_204B_RX1_PRBS_TEST_19_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x18C)))
#define JS_COMC_204B_RX1_PRBS_TEST_20_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x190)))
#define JS_COMC_204B_RX1_PRBS_TEST_21_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x194)))
#define JS_COMC_204B_RX1_PRBS_TEST_22_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x198)))
#define JS_COMC_204B_RX1_PRBS_TEST_23_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x19C)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_0_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1A0)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_1_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1A4)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_2_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1A8)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_3_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1AC)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_4_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1B0)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_5_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1B4)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_6_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1B8)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_7_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1BC)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_8_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1C0)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_9_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1C4)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_10_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1C8)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_11_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1CC)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_12_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1D0)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_13_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1D4)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_14_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1D8)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_15_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1DC)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_16_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1E0)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_17_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1E4)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_18_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1E8)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_19_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1EC)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_20_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1F0)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_21_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1F4)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_22_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1F8)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_23_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x1FC)))
#define JS_COMC_204B_RX1_PRBS_TEST_0_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x200)))
#define JS_COMC_204B_RX1_PRBS_TEST_1_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x204)))
#define JS_COMC_204B_RX1_PRBS_TEST_2_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x208)))
#define JS_COMC_204B_RX1_PRBS_TEST_3_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x20C)))
#define JS_COMC_204B_RX1_PRBS_TEST_4_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x210)))
#define JS_COMC_204B_RX1_PRBS_TEST_5_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x214)))
#define JS_COMC_204B_RX1_PRBS_TEST_6_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x218)))
#define JS_COMC_204B_RX1_PRBS_TEST_7_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x21C)))
#define JS_COMC_204B_RX1_PRBS_TEST_8_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x220)))
#define JS_COMC_204B_RX1_PRBS_TEST_9_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x224)))
#define JS_COMC_204B_RX1_PRBS_TEST_10_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x228)))
#define JS_COMC_204B_RX1_PRBS_TEST_11_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x22C)))
#define JS_COMC_204B_RX1_PRBS_TEST_12_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x230)))
#define JS_COMC_204B_RX1_PRBS_TEST_13_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x234)))
#define JS_COMC_204B_RX1_PRBS_TEST_14_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x238)))
#define JS_COMC_204B_RX1_PRBS_TEST_15_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x23C)))
#define JS_COMC_204B_RX1_PRBS_TEST_16_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x240)))
#define JS_COMC_204B_RX1_PRBS_TEST_17_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x244)))
#define JS_COMC_204B_RX1_PRBS_TEST_18_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x248)))
#define JS_COMC_204B_RX1_PRBS_TEST_19_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x24C)))
#define JS_COMC_204B_RX1_PRBS_TEST_20_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x250)))
#define JS_COMC_204B_RX1_PRBS_TEST_21_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x254)))
#define JS_COMC_204B_RX1_PRBS_TEST_22_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x258)))
#define JS_COMC_204B_RX1_PRBS_TEST_23_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x25C)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_0_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x260)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_1_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x264)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_2_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x268)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_3_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x26C)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_4_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x270)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_5_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x274)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_6_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x278)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_7_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x27C)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_8_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x280)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_9_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x284)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_10_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x288)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_11_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x28C)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_12_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x290)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_13_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x294)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_14_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x298)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_15_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x29C)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_16_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2A0)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_17_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2A4)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_18_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2A8)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_19_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2AC)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_20_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2B0)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_21_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2B4)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_22_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2B8)))
#define JS_COMC_204B_RX1_JTSPAT_TEST_23_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2BC)))
#define JS_COMC_204B_RX1_LMFC_LEMC_DELAY                    (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2E0)))
#define JS_COMC_204B_RX1_SYSREF_CONFIG                      (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2E4)))
#define JS_COMC_204B_RX1_MAST_INST                          (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2E8)))
#define JS_COMC_204B_RX1_SH_LOCK_STATUS                     (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2EC)))
#define JS_COMC_204B_RX1_SH_LOCK_LOSS_STATUS                (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2F0)))
#define JS_COMC_204B_RX1_EMB_LOCK_STATUS                    (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2F4)))
#define JS_COMC_204B_RX1_EMB_LOCK_LOSS_STATUS               (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x2F8)))
#define JS_COMC_204B_RX1_LEMC_BOUNDARY_PHASE                (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x3D8)))
#define JS_COMC_204B_RX1_RBD_LENGTH_OCTETS                  (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x3DC)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE0                 (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x300)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE1                 (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x304)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE2                 (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x308)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE3                 (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x30C)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE4                 (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x310)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE5                 (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x314)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE6                 (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x318)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE7                 (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x31C)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE8                 (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x320)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE9                 (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x324)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE10                (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x328)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE11                (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x32C)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE12                (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x330)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE13                (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x334)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE14                (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x338)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE15                (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x33C)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE16                (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x340)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE17                (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x344)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE18                (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x348)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE19                (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x34C)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE20                (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x350)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE21                (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x354)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE22                (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x358)))
#define JS_COMC_204B_RX1_ERROR_REPORT_LANE23                (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x35C)))
#define JS_COMC_204B_RX1_TRESH_EMB_ERR                      (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x360)))
#define JS_COMC_204B_RX1_TRESH_SH_ERR                       (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x364)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE0              (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x378)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE1              (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x37C)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE2              (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x380)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE3              (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x384)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE4              (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x388)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE5              (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x38C)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE6              (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x390)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE7              (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x394)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE8              (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x398)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE9              (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x39C)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE10             (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x3A0)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE11             (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x3A4)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE12             (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x3A8)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE13             (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x3AC)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE14             (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x3B0)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE15             (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x3B4)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE16             (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x3B8)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE17             (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x3BC)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE18             (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x3C0)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE19             (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x3C4)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE20             (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x3C8)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE21             (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x3CC)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE22             (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x3D0)))
#define JS_COMC_204B_RX1_ICOUNTER_REPORT_LANE23             (*((volatile uint32_t *)(JS_COMC_204B_RX1_BASE + 0x3D4)))

#define JS_COMC_204B_TX_BANK_ID                             (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x000)))
#define JS_COMC_204B_TX_DID                                 (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x004)))
#define JS_COMC_204B_TX_LID                                 (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x008)))
#define JS_COMC_204B_TX_LID2                                (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x00C)))
#define JS_COMC_204B_TX_LID3                                (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x010)))
#define JS_COMC_204B_TX_LID4                                (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x014)))
#define JS_COMC_204B_TX_DATAPATH_INTERCONNECT               (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x018)))
#define JS_COMC_204B_TX_SUBCLASS                            (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x01C)))
#define JS_COMC_204B_TX_CF                                  (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x020)))
#define JS_COMC_204B_TX_CS                                  (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x024)))
#define JS_COMC_204B_TX_F                                   (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x028)))
#define JS_COMC_204B_TX_K                                   (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x02C)))
#define JS_COMC_204B_TX_L                                   (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x030)))
#define JS_COMC_204B_TX_N                                   (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x034)))
#define JS_COMC_204B_TX_M                                   (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x038)))
#define JS_COMC_204B_TX_NTOTAL                              (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x03C)))
#define JS_COMC_204B_TX_S                                   (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x040)))
#define JS_COMC_204B_TX_HD                                  (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x044)))
#define JS_COMC_204B_TX_SCR                                 (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x048)))
#define JS_COMC_204B_TX_ENABLEMODULE                        (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x050)))
#define JS_COMC_204B_TX_ENABLELINKTEST                      (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x054)))
#define JS_COMC_204B_TX_GEN_SYSREF                          (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x3E4)))
#define JS_COMC_204B_TX_FEC_EN                              (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x2C4)))
#define JS_COMC_204B_TX_CRC3_EN                             (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x2C8)))
#define JS_COMC_204B_TX_CRC12_EN                            (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x2CC)))
#define JS_COMC_204B_TX_SOFT_SYNC                           (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x2D0)))
#define JS_COMC_204B_TX_E                                   (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x2D4)))
#define JS_COMC_204B_TX_BIT_ORDER                           (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x2D8)))
#define JS_COMC_204B_TX_TL_TEST_MODE                        (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x2DC)))
#define JS_COMC_204B_TX_RESYNC_COUNT_STATUS                 (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x2FC)))
#define JS_COMC_204B_TX_S_ON_IF_REG                         (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x368)))
//#define JS_COMC_204B_TX_MERGE_CF_GROUP                    (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x36C)))
#define JS_COMC_204B_TX_CMD_EN                              (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x370)))
#define JS_COMC_204B_TX_SYSREF_COUNTER_STATUS               (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x374)))
//#define JS_COMC_204B_TX_TAILBITS                          (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x058)))
#define JS_COMC_204B_TX_LINKTEST_CUSTOM_DATA                (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x05C)))
#define JS_COMC_204B_TX_LINKTEST_CUSTOM_ENABLE              (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x060)))
#define JS_COMC_204B_TX_FEATURE_DISABLE                     (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x120)))
#define JS_COMC_204B_TX_CORE_INTERRUPT_MASK                 (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x124)))
#define JS_COMC_204B_TX_CORE_INTERRUPT_STATUS               (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x128)))
#define JS_COMC_204B_TX_ILAS_DETAILS                        (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x12C)))
#define JS_COMC_204B_TX_CLK_RATIO                           (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x13C)))
#define JS_COMC_204B_TX_FIRST_SYMBOL_DISP                   (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x140)))
#define JS_COMC_204B_TX_TL_LATENCY                          (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x2C0)))
#define JS_COMC_204B_TX_LMFC_LEMC_DELAY                     (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x2E0)))
#define JS_COMC_204B_TX_SYSREF_CONFIG                       (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x2E4)))
#define JS_COMC_204B_TX_SAMPLE_REQ                          (*((volatile uint32_t *)(JS_COMC_204B_TX_BASE + 0x3E0)))

#define JS_COMC_204C_RX0_BANK_ID                            (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x000)))
#define JS_COMC_204C_RX0_DID                                (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x004)))
#define JS_COMC_204C_RX0_LID                                (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x008)))
#define JS_COMC_204C_RX0_LID2                               (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x00C)))
#define JS_COMC_204C_RX0_LID3                               (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x010)))
#define JS_COMC_204C_RX0_LID4                               (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x014)))
#define JS_COMC_204C_RX0_DATAPATH_INTERCONNECT              (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x018)))
#define JS_COMC_204C_RX0_SUBCLASS                           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x01C)))
#define JS_COMC_204C_RX0_CF                                 (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x020)))
#define JS_COMC_204C_RX0_CS                                 (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x024)))
#define JS_COMC_204C_RX0_F                                  (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x028)))
#define JS_COMC_204C_RX0_K                                  (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x02C)))
#define JS_COMC_204C_RX0_L                                  (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x030)))
#define JS_COMC_204C_RX0_N                                  (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x034)))
#define JS_COMC_204C_RX0_M                                  (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x038)))
#define JS_COMC_204C_RX0_NTOTAL                             (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x03C)))
#define JS_COMC_204C_RX0_S                                  (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x040)))
#define JS_COMC_204C_RX0_HD                                 (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x044)))
#define JS_COMC_204C_RX0_SCR                                (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x048)))
#define JS_COMC_204C_RX0_ENABLEMODULE                       (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x050)))
#define JS_COMC_204C_RX0_ENABLELINKTEST                     (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x054)))
#define JS_COMC_204C_RX0_GEN_SYSREF                         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x3E4)))
#define JS_COMC_204C_RX0_FEC_EN                             (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2C4)))
#define JS_COMC_204C_RX0_CRC3_EN                            (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2C8)))
#define JS_COMC_204C_RX0_CRC12_EN                           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2CC)))
#define JS_COMC_204C_RX0_SOFT_SYNC                          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2D0)))
#define JS_COMC_204C_RX0_E                                  (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2D4)))
#define JS_COMC_204C_RX0_BIT_ORDER                          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2D8)))
#define JS_COMC_204C_RX0_TL_TEST_MODE                       (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2DC)))
#define JS_COMC_204C_RX0_RESYNC_COUNT_STATUS                (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2FC)))
#define JS_COMC_204C_RX0_S_ON_IF_REG                        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x368)))
//#define JS_COMC_204C_RX0_MERGE_CF_GROUP                   (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x36C)))
#define JS_COMC_204C_RX0_CMD_EN                             (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x370)))
#define JS_COMC_204C_RX0_SYSREF_COUNTER_STATUS              (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x374)))
#define JS_COMC_204C_RX0_LINKCONFIGURATIONERROR             (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x04C)))
#define JS_COMC_204C_RX0_LINKTEST_0_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x058)))
#define JS_COMC_204C_RX0_LINKTEST_1_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x05C)))
#define JS_COMC_204C_RX0_LINKTEST_2_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x060)))
#define JS_COMC_204C_RX0_LINKTEST_3_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x064)))
#define JS_COMC_204C_RX0_LINKTEST_4_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x068)))
#define JS_COMC_204C_RX0_LINKTEST_5_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x06C)))
#define JS_COMC_204C_RX0_LINKTEST_6_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x070)))
#define JS_COMC_204C_RX0_LINKTEST_7_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x074)))
#define JS_COMC_204C_RX0_LINKTEST_8_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x078)))
#define JS_COMC_204C_RX0_LINKTEST_9_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x07C)))
#define JS_COMC_204C_RX0_LINKTEST_10_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x080)))
#define JS_COMC_204C_RX0_LINKTEST_11_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x084)))
#define JS_COMC_204C_RX0_LINKTEST_12_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x088)))
#define JS_COMC_204C_RX0_LINKTEST_13_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x08C)))
#define JS_COMC_204C_RX0_LINKTEST_14_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x090)))
#define JS_COMC_204C_RX0_LINKTEST_15_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x094)))
#define JS_COMC_204C_RX0_LINKTEST_16_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x098)))
#define JS_COMC_204C_RX0_LINKTEST_17_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x09C)))
#define JS_COMC_204C_RX0_LINKTEST_18_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0A0)))
#define JS_COMC_204C_RX0_LINKTEST_19_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0A4)))
#define JS_COMC_204C_RX0_LINKTEST_20_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0A8)))
#define JS_COMC_204C_RX0_LINKTEST_21_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0AC)))
#define JS_COMC_204C_RX0_LINKTEST_22_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0B0)))
#define JS_COMC_204C_RX0_LINKTEST_23_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0B4)))
#define JS_COMC_204C_RX0_LINKTEST_0_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0C0)))
#define JS_COMC_204C_RX0_LINKTEST_1_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0C4)))
#define JS_COMC_204C_RX0_LINKTEST_2_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0C8)))
#define JS_COMC_204C_RX0_LINKTEST_3_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0CC)))
#define JS_COMC_204C_RX0_LINKTEST_4_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0D0)))
#define JS_COMC_204C_RX0_LINKTEST_5_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0D4)))
#define JS_COMC_204C_RX0_LINKTEST_6_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0D8)))
#define JS_COMC_204C_RX0_LINKTEST_7_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0DC)))
#define JS_COMC_204C_RX0_LINKTEST_8_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0E0)))
#define JS_COMC_204C_RX0_LINKTEST_9_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0E4)))
#define JS_COMC_204C_RX0_LINKTEST_10_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0E8)))
#define JS_COMC_204C_RX0_LINKTEST_11_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0EC)))
#define JS_COMC_204C_RX0_LINKTEST_12_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0F0)))
#define JS_COMC_204C_RX0_LINKTEST_13_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0F4)))
#define JS_COMC_204C_RX0_LINKTEST_14_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0F8)))
#define JS_COMC_204C_RX0_LINKTEST_15_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x0FC)))
#define JS_COMC_204C_RX0_LINKTEST_16_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x100)))
#define JS_COMC_204C_RX0_LINKTEST_17_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x104)))
#define JS_COMC_204C_RX0_LINKTEST_18_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x108)))
#define JS_COMC_204C_RX0_LINKTEST_19_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x10C)))
#define JS_COMC_204C_RX0_LINKTEST_20_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x110)))
#define JS_COMC_204C_RX0_LINKTEST_21_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x114)))
#define JS_COMC_204C_RX0_LINKTEST_22_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x118)))
#define JS_COMC_204C_RX0_LINKTEST_23_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x11C)))
#define JS_COMC_204C_RX0_FEATURE_DISABLE                    (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x120)))
#define JS_COMC_204C_RX0_CORE_INTERRUPT_MASK                (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x124)))
#define JS_COMC_204C_RX0_CORE_INTERRUPT_STATUS              (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x128)))
#define JS_COMC_204C_RX0_ILAS_DETAILS                       (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x12C)))
#define JS_COMC_204C_RX0_ERR_INJ_REQ                        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x130)))
#define JS_COMC_204C_RX0_CLK_RATIO                          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x13C)))
#define JS_COMC_204C_RX0_PRBS_TEST_0_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x140)))
#define JS_COMC_204C_RX0_PRBS_TEST_1_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x144)))
#define JS_COMC_204C_RX0_PRBS_TEST_2_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x148)))
#define JS_COMC_204C_RX0_PRBS_TEST_3_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x14C)))
#define JS_COMC_204C_RX0_PRBS_TEST_4_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x150)))
#define JS_COMC_204C_RX0_PRBS_TEST_5_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x154)))
#define JS_COMC_204C_RX0_PRBS_TEST_6_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x158)))
#define JS_COMC_204C_RX0_PRBS_TEST_7_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x15C)))
#define JS_COMC_204C_RX0_PRBS_TEST_8_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x160)))
#define JS_COMC_204C_RX0_PRBS_TEST_9_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x164)))
#define JS_COMC_204C_RX0_PRBS_TEST_10_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x168)))
#define JS_COMC_204C_RX0_PRBS_TEST_11_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x16C)))
#define JS_COMC_204C_RX0_PRBS_TEST_12_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x170)))
#define JS_COMC_204C_RX0_PRBS_TEST_13_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x174)))
#define JS_COMC_204C_RX0_PRBS_TEST_14_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x178)))
#define JS_COMC_204C_RX0_PRBS_TEST_15_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x17C)))
#define JS_COMC_204C_RX0_PRBS_TEST_16_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x180)))
#define JS_COMC_204C_RX0_PRBS_TEST_17_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x184)))
#define JS_COMC_204C_RX0_PRBS_TEST_18_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x188)))
#define JS_COMC_204C_RX0_PRBS_TEST_19_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x18C)))
#define JS_COMC_204C_RX0_PRBS_TEST_20_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x190)))
#define JS_COMC_204C_RX0_PRBS_TEST_21_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x194)))
#define JS_COMC_204C_RX0_PRBS_TEST_22_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x198)))
#define JS_COMC_204C_RX0_PRBS_TEST_23_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x19C)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_0_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1A0)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_1_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1A4)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_2_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1A8)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_3_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1AC)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_4_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1B0)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_5_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1B4)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_6_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1B8)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_7_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1BC)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_8_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1C0)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_9_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1C4)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_10_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1C8)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_11_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1CC)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_12_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1D0)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_13_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1D4)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_14_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1D8)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_15_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1DC)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_16_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1E0)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_17_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1E4)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_18_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1E8)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_19_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1EC)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_20_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1F0)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_21_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1F4)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_22_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1F8)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_23_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x1FC)))
#define JS_COMC_204C_RX0_PRBS_TEST_0_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x200)))
#define JS_COMC_204C_RX0_PRBS_TEST_1_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x204)))
#define JS_COMC_204C_RX0_PRBS_TEST_2_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x208)))
#define JS_COMC_204C_RX0_PRBS_TEST_3_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x20C)))
#define JS_COMC_204C_RX0_PRBS_TEST_4_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x210)))
#define JS_COMC_204C_RX0_PRBS_TEST_5_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x214)))
#define JS_COMC_204C_RX0_PRBS_TEST_6_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x218)))
#define JS_COMC_204C_RX0_PRBS_TEST_7_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x21C)))
#define JS_COMC_204C_RX0_PRBS_TEST_8_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x220)))
#define JS_COMC_204C_RX0_PRBS_TEST_9_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x224)))
#define JS_COMC_204C_RX0_PRBS_TEST_10_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x228)))
#define JS_COMC_204C_RX0_PRBS_TEST_11_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x22C)))
#define JS_COMC_204C_RX0_PRBS_TEST_12_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x230)))
#define JS_COMC_204C_RX0_PRBS_TEST_13_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x234)))
#define JS_COMC_204C_RX0_PRBS_TEST_14_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x238)))
#define JS_COMC_204C_RX0_PRBS_TEST_15_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x23C)))
#define JS_COMC_204C_RX0_PRBS_TEST_16_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x240)))
#define JS_COMC_204C_RX0_PRBS_TEST_17_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x244)))
#define JS_COMC_204C_RX0_PRBS_TEST_18_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x248)))
#define JS_COMC_204C_RX0_PRBS_TEST_19_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x24C)))
#define JS_COMC_204C_RX0_PRBS_TEST_20_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x250)))
#define JS_COMC_204C_RX0_PRBS_TEST_21_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x254)))
#define JS_COMC_204C_RX0_PRBS_TEST_22_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x258)))
#define JS_COMC_204C_RX0_PRBS_TEST_23_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x25C)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_0_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x260)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_1_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x264)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_2_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x268)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_3_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x26C)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_4_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x270)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_5_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x274)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_6_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x278)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_7_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x27C)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_8_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x280)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_9_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x284)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_10_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x288)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_11_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x28C)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_12_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x290)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_13_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x294)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_14_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x298)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_15_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x29C)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_16_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2A0)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_17_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2A4)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_18_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2A8)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_19_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2AC)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_20_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2B0)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_21_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2B4)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_22_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2B8)))
#define JS_COMC_204C_RX0_JTSPAT_TEST_23_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2BC)))
#define JS_COMC_204C_RX0_LMFC_LEMC_DELAY                    (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2E0)))
#define JS_COMC_204C_RX0_SYSREF_CONFIG                      (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2E4)))
#define JS_COMC_204C_RX0_MAST_INST                          (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2E8)))
#define JS_COMC_204C_RX0_SH_LOCK_STATUS                     (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2EC)))
#define JS_COMC_204C_RX0_SH_LOCK_LOSS_STATUS                (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2F0)))
#define JS_COMC_204C_RX0_EMB_LOCK_STATUS                    (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2F4)))
#define JS_COMC_204C_RX0_EMB_LOCK_LOSS_STATUS               (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x2F8)))
#define JS_COMC_204C_RX0_LEMC_BOUNDARY_PHASE                (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x3D8)))
#define JS_COMC_204C_RX0_RBD_LENGTH_OCTETS                  (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x3DC)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE0                 (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x300)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE1                 (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x304)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE2                 (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x308)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE3                 (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x30C)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE4                 (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x310)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE5                 (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x314)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE6                 (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x318)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE7                 (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x31C)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE8                 (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x320)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE9                 (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x324)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE10                (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x328)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE11                (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x32C)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE12                (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x330)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE13                (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x334)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE14                (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x338)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE15                (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x33C)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE16                (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x340)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE17                (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x344)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE18                (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x348)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE19                (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x34C)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE20                (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x350)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE21                (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x354)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE22                (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x358)))
#define JS_COMC_204C_RX0_ERROR_REPORT_LANE23                (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x35C)))
#define JS_COMC_204C_RX0_TRESH_EMB_ERR                      (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x360)))
#define JS_COMC_204C_RX0_TRESH_SH_ERR                       (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x364)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE0              (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x378)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE1              (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x37C)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE2              (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x380)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE3              (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x384)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE4              (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x388)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE5              (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x38C)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE6              (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x390)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE7              (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x394)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE8              (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x398)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE9              (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x39C)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE10             (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x3A0)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE11             (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x3A4)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE12             (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x3A8)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE13             (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x3AC)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE14             (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x3B0)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE15             (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x3B4)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE16             (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x3B8)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE17             (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x3BC)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE18             (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x3C0)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE19             (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x3C4)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE20             (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x3C8)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE21             (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x3CC)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE22             (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x3D0)))
#define JS_COMC_204C_RX0_ICOUNTER_REPORT_LANE23             (*((volatile uint32_t *)(JS_COMC_204C_RX0_BASE + 0x3D4)))

#define JS_COMC_204C_RX1_BANK_ID                            (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x000)))
#define JS_COMC_204C_RX1_DID                                (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x004)))
#define JS_COMC_204C_RX1_LID                                (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x008)))
#define JS_COMC_204C_RX1_LID2                               (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x00C)))
#define JS_COMC_204C_RX1_LID3                               (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x010)))
#define JS_COMC_204C_RX1_LID4                               (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x014)))
#define JS_COMC_204C_RX1_DATAPATH_INTERCONNECT              (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x018)))
#define JS_COMC_204C_RX1_SUBCLASS                           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x01C)))
#define JS_COMC_204C_RX1_CF                                 (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x020)))
#define JS_COMC_204C_RX1_CS                                 (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x024)))
#define JS_COMC_204C_RX1_F                                  (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x028)))
#define JS_COMC_204C_RX1_K                                  (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x02C)))
#define JS_COMC_204C_RX1_L                                  (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x030)))
#define JS_COMC_204C_RX1_N                                  (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x034)))
#define JS_COMC_204C_RX1_M                                  (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x038)))
#define JS_COMC_204C_RX1_NTOTAL                             (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x03C)))
#define JS_COMC_204C_RX1_S                                  (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x040)))
#define JS_COMC_204C_RX1_HD                                 (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x044)))
#define JS_COMC_204C_RX1_SCR                                (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x048)))
#define JS_COMC_204C_RX1_ENABLEMODULE                       (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x050)))
#define JS_COMC_204C_RX1_ENABLELINKTEST                     (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x054)))
#define JS_COMC_204C_RX1_GEN_SYSREF                         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x3E4)))
#define JS_COMC_204C_RX1_FEC_EN                             (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2C4)))
#define JS_COMC_204C_RX1_CRC3_EN                            (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2C8)))
#define JS_COMC_204C_RX1_CRC12_EN                           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2CC)))
#define JS_COMC_204C_RX1_SOFT_SYNC                          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2D0)))
#define JS_COMC_204C_RX1_E                                  (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2D4)))
#define JS_COMC_204C_RX1_BIT_ORDER                          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2D8)))
#define JS_COMC_204C_RX1_TL_TEST_MODE                       (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2DC)))
#define JS_COMC_204C_RX1_RESYNC_COUNT_STATUS                (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2FC)))
#define JS_COMC_204C_RX1_S_ON_IF_REG                        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x368)))
//#define JS_COMC_204C_RX1_MERGE_CF_GROUP                   (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x36C)))
#define JS_COMC_204C_RX1_CMD_EN                             (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x370)))
#define JS_COMC_204C_RX1_SYSREF_COUNTER_STATUS              (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x374)))
#define JS_COMC_204C_RX1_LINKCONFIGURATIONERROR             (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x04C)))
#define JS_COMC_204C_RX1_LINKTEST_0_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x058)))
#define JS_COMC_204C_RX1_LINKTEST_1_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x05C)))
#define JS_COMC_204C_RX1_LINKTEST_2_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x060)))
#define JS_COMC_204C_RX1_LINKTEST_3_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x064)))
#define JS_COMC_204C_RX1_LINKTEST_4_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x068)))
#define JS_COMC_204C_RX1_LINKTEST_5_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x06C)))
#define JS_COMC_204C_RX1_LINKTEST_6_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x070)))
#define JS_COMC_204C_RX1_LINKTEST_7_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x074)))
#define JS_COMC_204C_RX1_LINKTEST_8_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x078)))
#define JS_COMC_204C_RX1_LINKTEST_9_RECEIVECOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x07C)))
#define JS_COMC_204C_RX1_LINKTEST_10_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x080)))
#define JS_COMC_204C_RX1_LINKTEST_11_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x084)))
#define JS_COMC_204C_RX1_LINKTEST_12_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x088)))
#define JS_COMC_204C_RX1_LINKTEST_13_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x08C)))
#define JS_COMC_204C_RX1_LINKTEST_14_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x090)))
#define JS_COMC_204C_RX1_LINKTEST_15_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x094)))
#define JS_COMC_204C_RX1_LINKTEST_16_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x098)))
#define JS_COMC_204C_RX1_LINKTEST_17_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x09C)))
#define JS_COMC_204C_RX1_LINKTEST_18_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0A0)))
#define JS_COMC_204C_RX1_LINKTEST_19_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0A4)))
#define JS_COMC_204C_RX1_LINKTEST_20_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0A8)))
#define JS_COMC_204C_RX1_LINKTEST_21_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0AC)))
#define JS_COMC_204C_RX1_LINKTEST_22_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0B0)))
#define JS_COMC_204C_RX1_LINKTEST_23_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0B4)))
#define JS_COMC_204C_RX1_LINKTEST_0_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0C0)))
#define JS_COMC_204C_RX1_LINKTEST_1_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0C4)))
#define JS_COMC_204C_RX1_LINKTEST_2_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0C8)))
#define JS_COMC_204C_RX1_LINKTEST_3_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0CC)))
#define JS_COMC_204C_RX1_LINKTEST_4_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0D0)))
#define JS_COMC_204C_RX1_LINKTEST_5_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0D4)))
#define JS_COMC_204C_RX1_LINKTEST_6_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0D8)))
#define JS_COMC_204C_RX1_LINKTEST_7_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0DC)))
#define JS_COMC_204C_RX1_LINKTEST_8_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0E0)))
#define JS_COMC_204C_RX1_LINKTEST_9_ERRORCOUNTER            (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0E4)))
#define JS_COMC_204C_RX1_LINKTEST_10_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0E8)))
#define JS_COMC_204C_RX1_LINKTEST_11_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0EC)))
#define JS_COMC_204C_RX1_LINKTEST_12_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0F0)))
#define JS_COMC_204C_RX1_LINKTEST_13_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0F4)))
#define JS_COMC_204C_RX1_LINKTEST_14_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0F8)))
#define JS_COMC_204C_RX1_LINKTEST_15_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x0FC)))
#define JS_COMC_204C_RX1_LINKTEST_16_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x100)))
#define JS_COMC_204C_RX1_LINKTEST_17_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x104)))
#define JS_COMC_204C_RX1_LINKTEST_18_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x108)))
#define JS_COMC_204C_RX1_LINKTEST_19_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x10C)))
#define JS_COMC_204C_RX1_LINKTEST_20_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x110)))
#define JS_COMC_204C_RX1_LINKTEST_21_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x114)))
#define JS_COMC_204C_RX1_LINKTEST_22_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x118)))
#define JS_COMC_204C_RX1_LINKTEST_23_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x11C)))
#define JS_COMC_204C_RX1_FEATURE_DISABLE                    (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x120)))
#define JS_COMC_204C_RX1_CORE_INTERRUPT_MASK                (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x124)))
#define JS_COMC_204C_RX1_CORE_INTERRUPT_STATUS              (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x128)))
#define JS_COMC_204C_RX1_ILAS_DETAILS                       (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x12C)))
#define JS_COMC_204C_RX1_ERR_INJ_REQ                        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x130)))
#define JS_COMC_204C_RX1_CLK_RATIO                          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x13C)))
#define JS_COMC_204C_RX1_PRBS_TEST_0_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x140)))
#define JS_COMC_204C_RX1_PRBS_TEST_1_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x144)))
#define JS_COMC_204C_RX1_PRBS_TEST_2_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x148)))
#define JS_COMC_204C_RX1_PRBS_TEST_3_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x14C)))
#define JS_COMC_204C_RX1_PRBS_TEST_4_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x150)))
#define JS_COMC_204C_RX1_PRBS_TEST_5_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x154)))
#define JS_COMC_204C_RX1_PRBS_TEST_6_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x158)))
#define JS_COMC_204C_RX1_PRBS_TEST_7_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x15C)))
#define JS_COMC_204C_RX1_PRBS_TEST_8_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x160)))
#define JS_COMC_204C_RX1_PRBS_TEST_9_ERRORCOUNTER           (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x164)))
#define JS_COMC_204C_RX1_PRBS_TEST_10_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x168)))
#define JS_COMC_204C_RX1_PRBS_TEST_11_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x16C)))
#define JS_COMC_204C_RX1_PRBS_TEST_12_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x170)))
#define JS_COMC_204C_RX1_PRBS_TEST_13_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x174)))
#define JS_COMC_204C_RX1_PRBS_TEST_14_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x178)))
#define JS_COMC_204C_RX1_PRBS_TEST_15_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x17C)))
#define JS_COMC_204C_RX1_PRBS_TEST_16_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x180)))
#define JS_COMC_204C_RX1_PRBS_TEST_17_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x184)))
#define JS_COMC_204C_RX1_PRBS_TEST_18_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x188)))
#define JS_COMC_204C_RX1_PRBS_TEST_19_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x18C)))
#define JS_COMC_204C_RX1_PRBS_TEST_20_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x190)))
#define JS_COMC_204C_RX1_PRBS_TEST_21_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x194)))
#define JS_COMC_204C_RX1_PRBS_TEST_22_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x198)))
#define JS_COMC_204C_RX1_PRBS_TEST_23_ERRORCOUNTER          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x19C)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_0_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1A0)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_1_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1A4)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_2_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1A8)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_3_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1AC)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_4_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1B0)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_5_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1B4)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_6_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1B8)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_7_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1BC)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_8_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1C0)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_9_ERRORCOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1C4)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_10_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1C8)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_11_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1CC)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_12_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1D0)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_13_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1D4)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_14_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1D8)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_15_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1DC)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_16_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1E0)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_17_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1E4)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_18_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1E8)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_19_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1EC)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_20_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1F0)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_21_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1F4)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_22_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1F8)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_23_ERRORCOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x1FC)))
#define JS_COMC_204C_RX1_PRBS_TEST_0_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x200)))
#define JS_COMC_204C_RX1_PRBS_TEST_1_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x204)))
#define JS_COMC_204C_RX1_PRBS_TEST_2_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x208)))
#define JS_COMC_204C_RX1_PRBS_TEST_3_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x20C)))
#define JS_COMC_204C_RX1_PRBS_TEST_4_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x210)))
#define JS_COMC_204C_RX1_PRBS_TEST_5_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x214)))
#define JS_COMC_204C_RX1_PRBS_TEST_6_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x218)))
#define JS_COMC_204C_RX1_PRBS_TEST_7_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x21C)))
#define JS_COMC_204C_RX1_PRBS_TEST_8_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x220)))
#define JS_COMC_204C_RX1_PRBS_TEST_9_RECEIVECOUNTER         (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x224)))
#define JS_COMC_204C_RX1_PRBS_TEST_10_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x228)))
#define JS_COMC_204C_RX1_PRBS_TEST_11_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x22C)))
#define JS_COMC_204C_RX1_PRBS_TEST_12_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x230)))
#define JS_COMC_204C_RX1_PRBS_TEST_13_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x234)))
#define JS_COMC_204C_RX1_PRBS_TEST_14_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x238)))
#define JS_COMC_204C_RX1_PRBS_TEST_15_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x23C)))
#define JS_COMC_204C_RX1_PRBS_TEST_16_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x240)))
#define JS_COMC_204C_RX1_PRBS_TEST_17_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x244)))
#define JS_COMC_204C_RX1_PRBS_TEST_18_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x248)))
#define JS_COMC_204C_RX1_PRBS_TEST_19_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x24C)))
#define JS_COMC_204C_RX1_PRBS_TEST_20_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x250)))
#define JS_COMC_204C_RX1_PRBS_TEST_21_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x254)))
#define JS_COMC_204C_RX1_PRBS_TEST_22_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x258)))
#define JS_COMC_204C_RX1_PRBS_TEST_23_RECEIVECOUNTER        (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x25C)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_0_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x260)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_1_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x264)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_2_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x268)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_3_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x26C)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_4_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x270)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_5_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x274)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_6_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x278)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_7_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x27C)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_8_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x280)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_9_RECEIVECOUNTER       (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x284)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_10_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x288)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_11_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x28C)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_12_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x290)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_13_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x294)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_14_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x298)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_15_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x29C)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_16_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2A0)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_17_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2A4)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_18_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2A8)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_19_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2AC)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_20_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2B0)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_21_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2B4)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_22_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2B8)))
#define JS_COMC_204C_RX1_JTSPAT_TEST_23_RECEIVECOUNTER      (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2BC)))
#define JS_COMC_204C_RX1_LMFC_LEMC_DELAY                    (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2E0)))
#define JS_COMC_204C_RX1_SYSREF_CONFIG                      (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2E4)))
#define JS_COMC_204C_RX1_MAST_INST                          (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2E8)))
#define JS_COMC_204C_RX1_SH_LOCK_STATUS                     (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2EC)))
#define JS_COMC_204C_RX1_SH_LOCK_LOSS_STATUS                (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2F0)))
#define JS_COMC_204C_RX1_EMB_LOCK_STATUS                    (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2F4)))
#define JS_COMC_204C_RX1_EMB_LOCK_LOSS_STATUS               (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x2F8)))
#define JS_COMC_204C_RX1_LEMC_BOUNDARY_PHASE                (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x3D8)))
#define JS_COMC_204C_RX1_RBD_LENGTH_OCTETS                  (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x3DC)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE0                 (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x300)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE1                 (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x304)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE2                 (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x308)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE3                 (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x30C)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE4                 (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x310)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE5                 (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x314)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE6                 (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x318)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE7                 (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x31C)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE8                 (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x320)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE9                 (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x324)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE10                (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x328)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE11                (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x32C)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE12                (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x330)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE13                (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x334)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE14                (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x338)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE15                (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x33C)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE16                (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x340)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE17                (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x344)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE18                (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x348)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE19                (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x34C)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE20                (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x350)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE21                (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x354)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE22                (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x358)))
#define JS_COMC_204C_RX1_ERROR_REPORT_LANE23                (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x35C)))
#define JS_COMC_204C_RX1_TRESH_EMB_ERR                      (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x360)))
#define JS_COMC_204C_RX1_TRESH_SH_ERR                       (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x364)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE0              (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x378)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE1              (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x37C)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE2              (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x380)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE3              (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x384)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE4              (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x388)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE5              (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x38C)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE6              (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x390)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE7              (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x394)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE8              (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x398)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE9              (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x39C)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE10             (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x3A0)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE11             (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x3A4)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE12             (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x3A8)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE13             (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x3AC)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE14             (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x3B0)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE15             (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x3B4)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE16             (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x3B8)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE17             (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x3BC)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE18             (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x3C0)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE19             (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x3C4)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE20             (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x3C8)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE21             (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x3CC)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE22             (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x3D0)))
#define JS_COMC_204C_RX1_ICOUNTER_REPORT_LANE23             (*((volatile uint32_t *)(JS_COMC_204C_RX1_BASE + 0x3D4)))

#define JS_COMC_204C_TX_BANK_ID                             (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x000)))
#define JS_COMC_204C_TX_DID                                 (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x004)))
#define JS_COMC_204C_TX_LID                                 (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x008)))
#define JS_COMC_204C_TX_LID2                                (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x00C)))
#define JS_COMC_204C_TX_LID3                                (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x010)))
#define JS_COMC_204C_TX_LID4                                (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x014)))
#define JS_COMC_204C_TX_DATAPATH_INTERCONNECT               (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x018)))
#define JS_COMC_204C_TX_SUBCLASS                            (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x01C)))
#define JS_COMC_204C_TX_CF                                  (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x020)))
#define JS_COMC_204C_TX_CS                                  (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x024)))
#define JS_COMC_204C_TX_F                                   (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x028)))
#define JS_COMC_204C_TX_K                                   (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x02C)))
#define JS_COMC_204C_TX_L                                   (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x030)))
#define JS_COMC_204C_TX_N                                   (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x034)))
#define JS_COMC_204C_TX_M                                   (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x038)))
#define JS_COMC_204C_TX_NTOTAL                              (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x03C)))
#define JS_COMC_204C_TX_S                                   (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x040)))
#define JS_COMC_204C_TX_HD                                  (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x044)))
#define JS_COMC_204C_TX_SCR                                 (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x048)))
#define JS_COMC_204C_TX_ENABLEMODULE                        (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x050)))
#define JS_COMC_204C_TX_ENABLELINKTEST                      (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x054)))
#define JS_COMC_204C_TX_GEN_SYSREF                          (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x3E4)))
#define JS_COMC_204C_TX_FEC_EN                              (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x2C4)))
#define JS_COMC_204C_TX_CRC3_EN                             (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x2C8)))
#define JS_COMC_204C_TX_CRC12_EN                            (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x2CC)))
#define JS_COMC_204C_TX_SOFT_SYNC                           (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x2D0)))
#define JS_COMC_204C_TX_E                                   (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x2D4)))
#define JS_COMC_204C_TX_BIT_ORDER                           (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x2D8)))
#define JS_COMC_204C_TX_TL_TEST_MODE                        (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x2DC)))
#define JS_COMC_204C_TX_RESYNC_COUNT_STATUS                 (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x2FC)))
#define JS_COMC_204C_TX_S_ON_IF_REG                         (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x368)))
//#define JS_COMC_204C_TX_MERGE_CF_GROUP                    (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x36C)))
#define JS_COMC_204C_TX_CMD_EN                              (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x370)))
#define JS_COMC_204C_TX_SYSREF_COUNTER_STATUS               (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x374)))
//#define JS_COMC_204C_TX_TAILBITS                          (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x058)))
#define JS_COMC_204C_TX_LINKTEST_CUSTOM_DATA                (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x05C)))
#define JS_COMC_204C_TX_LINKTEST_CUSTOM_ENABLE              (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x060)))
#define JS_COMC_204C_TX_FEATURE_DISABLE                     (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x120)))
#define JS_COMC_204C_TX_CORE_INTERRUPT_MASK                 (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x124)))
#define JS_COMC_204C_TX_CORE_INTERRUPT_STATUS               (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x128)))
#define JS_COMC_204C_TX_ILAS_DETAILS                        (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x12C)))
#define JS_COMC_204C_TX_CLK_RATIO                           (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x13C)))
#define JS_COMC_204C_TX_FIRST_SYMBOL_DISP                   (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x140)))
#define JS_COMC_204C_TX_TL_LATENCY                          (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x2C0)))
#define JS_COMC_204C_TX_LMFC_LEMC_DELAY                     (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x2E0)))
#define JS_COMC_204C_TX_SYSREF_CONFIG                       (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x2E4)))
#define JS_COMC_204C_TX_SAMPLE_REQ                          (*((volatile uint32_t *)(JS_COMC_204C_TX_BASE + 0x3E0)))


#define JS_204B_RX0_SUBCTRL_SH_LOCK                         (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x014)))
#define JS_204B_RX0_SUBCTRL_EMB_LOCK                        (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x018)))
#define JS_204B_RX0_SUBCTRL_RX_CMD                          (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x020)))
#define JS_204B_RX0_SUBCTRL_CMD_ERR_CNT_0                   (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x024)))
#define JS_204B_RX0_SUBCTRL_CMD_ERR_CNT_1                   (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x028)))
#define JS_204B_RX0_SUBCTRL_CMD_VALID_APB_CNT               (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x02C)))
#define JS_204B_RX0_SUBCTRL_SYSREF_CNT                      (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x030)))
#define JS_204B_RX0_SUBCTRL_SAM_IF_RECORD                   (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x034)))
#define JS_204B_RX0_SUBCTRL_MAP_IF_RECORD                   (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x038)))
#define JS_204B_RX0_SUBCTRL_SERDES_IF_RECORD                (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x03C)))
#define JS_204B_RX0_SUBCTRL_SYSREF_RX_SEL                   (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x040)))
#define JS_204B_RX0_SUBCTRL_SYNC_B_SEL                      (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x044)))
#define JS_204B_RX0_SUBCTRL_INTR_MASK                       (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x048)))
#define JS_204B_RX0_SUBCTRL_INTR_TH_0                       (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x04C)))
#define JS_204B_RX0_SUBCTRL_INTR_TH_1                       (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x050)))
#define JS_204B_RX0_SUBCTRL_INTR_TH_2                       (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x054)))
#define JS_204B_RX0_SUBCTRL_INTR_TH_3                       (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x058)))
#define JS_204B_RX0_SUBCTRL_SYSREF                          (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x05C)))
#define JS_204B_RX0_SUBCTRL_INTR_FLAG                       (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x060)))
#define JS_204B_RX0_SUBCTRL_SAM_ERR_CNT                     (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x064)))
#define JS_204B_RX0_SUBCTRL_TL_TEST_MODE_CNT                (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x068)))
#define JS_204B_RX0_SUBCTRL_SAM_IF_RECORD_DATA              (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x0800)))
#define JS_204B_RX0_SUBCTRL_MAP_IF_RECORD_DATA              (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x1000)))
#define JS_204B_RX0_SUBCTRL_SERDES_IF_RECORD_DATA           (*((volatile uint32_t *)(JS_204B_RX0_SUBCTRL_BASE + 0x1400)))

#define JS_204B_RX1_SUBCTRL_SH_LOCK                         (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x014)))
#define JS_204B_RX1_SUBCTRL_EMB_LOCK                        (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x018)))
#define JS_204B_RX1_SUBCTRL_RX_CMD                          (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x020)))
#define JS_204B_RX1_SUBCTRL_CMD_ERR_CNT_0                   (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x024)))
#define JS_204B_RX1_SUBCTRL_CMD_ERR_CNT_1                   (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x028)))
#define JS_204B_RX1_SUBCTRL_CMD_VALID_APB_CNT               (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x02C)))
#define JS_204B_RX1_SUBCTRL_SYSREF_CNT                      (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x030)))
#define JS_204B_RX1_SUBCTRL_SAM_IF_RECORD                   (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x034)))
#define JS_204B_RX1_SUBCTRL_MAP_IF_RECORD                   (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x038)))
#define JS_204B_RX1_SUBCTRL_SERDES_IF_RECORD                (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x03C)))
#define JS_204B_RX1_SUBCTRL_SYSREF_RX_SEL                   (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x040)))
#define JS_204B_RX1_SUBCTRL_SYNC_B_SEL                      (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x044)))
#define JS_204B_RX1_SUBCTRL_INTR_MASK                       (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x048)))
#define JS_204B_RX1_SUBCTRL_INTR_TH_0                       (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x04C)))
#define JS_204B_RX1_SUBCTRL_INTR_TH_1                       (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x050)))
#define JS_204B_RX1_SUBCTRL_INTR_TH_2                       (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x054)))
#define JS_204B_RX1_SUBCTRL_INTR_TH_3                       (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x058)))
#define JS_204B_RX1_SUBCTRL_SYSREF                          (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x05C)))
#define JS_204B_RX1_SUBCTRL_INTR_FLAG                       (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x060)))
#define JS_204B_RX1_SUBCTRL_SAM_ERR_CNT                     (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x064)))
#define JS_204B_RX1_SUBCTRL_TL_TEST_MODE_CNT                (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x068)))
#define JS_204B_RX1_SUBCTRL_SAM_IF_RECORD_DATA              (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x0800)))
#define JS_204B_RX1_SUBCTRL_MAP_IF_RECORD_DATA              (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x1000)))
#define JS_204B_RX1_SUBCTRL_SERDES_IF_RECORD_DATA           (*((volatile uint32_t *)(JS_204B_RX1_SUBCTRL_BASE + 0x1800)))

#define JS_204B_TX_SUBCTRL_SAM_IF_RECORD_EN                 (*((volatile uint32_t *)(JS_204B_TX_SUBCTRL_BASE + 0x014)))
#define JS_204B_TX_SUBCTRL_SERDES_IF_RECORD_EN              (*((volatile uint32_t *)(JS_204B_TX_SUBCTRL_BASE + 0x018)))
#define JS_204B_TX_SUBCTRL_TRANS_TH                         (*((volatile uint32_t *)(JS_204B_TX_SUBCTRL_BASE + 0x01C)))
#define JS_204B_TX_SUBCTRL_SYSREF_TX_SEL                    (*((volatile uint32_t *)(JS_204B_TX_SUBCTRL_BASE + 0x020)))
#define JS_204B_TX_SUBCTRL_SYNC_B_SEL                       (*((volatile uint32_t *)(JS_204B_TX_SUBCTRL_BASE + 0x024)))
#define JS_204B_TX_SUBCTRL_TX_CMD                           (*((volatile uint32_t *)(JS_204B_TX_SUBCTRL_BASE + 0x028)))
#define JS_204B_TX_SUBCTRL_CMD_APB_VALID_CNT                (*((volatile uint32_t *)(JS_204B_TX_SUBCTRL_BASE + 0x02C)))
#define JS_204B_TX_SUBCTRL_CMD_SENT_CNT                     (*((volatile uint32_t *)(JS_204B_TX_SUBCTRL_BASE + 0x030)))
#define JS_204B_TX_SUBCTRL_SAM_DATA_IDLE_ARRAY0             (*((volatile uint32_t *)(JS_204B_TX_SUBCTRL_BASE + 0x038)))
#define JS_204B_TX_SUBCTRL_SAM_DATA_IDLE_ARRAY1             (*((volatile uint32_t *)(JS_204B_TX_SUBCTRL_BASE + 0x03C)))
#define JS_204B_TX_SUBCTRL_SAM_DATA_IDLE_ARRAY2             (*((volatile uint32_t *)(JS_204B_TX_SUBCTRL_BASE + 0x040)))
#define JS_204B_TX_SUBCTRL_SAM_DATA_IDLE_ARRAY3             (*((volatile uint32_t *)(JS_204B_TX_SUBCTRL_BASE + 0x044)))
#define JS_204B_TX_SUBCTRL_SAM_DATA_IDLE_ARRAY4             (*((volatile uint32_t *)(JS_204B_TX_SUBCTRL_BASE + 0x048)))
#define JS_204B_TX_SUBCTRL_SAM_DATA_IDLE_ARRAY5             (*((volatile uint32_t *)(JS_204B_TX_SUBCTRL_BASE + 0x04C)))
#define JS_204B_TX_SUBCTRL_SAM_DATA_IDLE_ARRAY6             (*((volatile uint32_t *)(JS_204B_TX_SUBCTRL_BASE + 0x050)))
#define JS_204B_TX_SUBCTRL_SAM_DATA_IDLE_ARRAY7             (*((volatile uint32_t *)(JS_204B_TX_SUBCTRL_BASE + 0x054)))
#define JS_204B_TX_SUBCTRL_SAM_DATA_IDLE_CNT                (*((volatile uint32_t *)(JS_204B_TX_SUBCTRL_BASE + 0x058)))
#define JS_204B_TX_SUBCTRL_SAM_IF_RECORD_DONE               (*((volatile uint32_t *)(JS_204B_TX_SUBCTRL_BASE + 0x05C)))
#define JS_204B_TX_SUBCTRL_SERDES_IF_RECORD_DONE            (*((volatile uint32_t *)(JS_204B_TX_SUBCTRL_BASE + 0x060)))
#define JS_204B_TX_SUBCTRL_SAM_IF_RECORD_DATA               (*((volatile uint32_t *)(JS_204B_TX_SUBCTRL_BASE + 0x800)))
#define JS_204B_TX_SUBCTRL_SERDES_IF_RECORD_DATA            (*((volatile uint32_t *)(JS_204B_TX_SUBCTRL_BASE + 0x1000)))

#define JS_204C_RX0_SUBCTRL_SH_LOCK                         (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x014)))
#define JS_204C_RX0_SUBCTRL_EMB_LOCK                        (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x018)))
#define JS_204C_RX0_SUBCTRL_RX_CMD                          (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x020)))
#define JS_204C_RX0_SUBCTRL_CMD_ERR_CNT_0                   (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x024)))
#define JS_204C_RX0_SUBCTRL_CMD_ERR_CNT_1                   (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x028)))
#define JS_204C_RX0_SUBCTRL_CMD_VALID_APB_CNT               (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x02C)))
#define JS_204C_RX0_SUBCTRL_SYSREF_CNT                      (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x030)))
#define JS_204C_RX0_SUBCTRL_SAM_IF_RECORD                   (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x034)))
#define JS_204C_RX0_SUBCTRL_MAP_IF_RECORD                   (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x038)))
#define JS_204C_RX0_SUBCTRL_SERDES_IF_RECORD                (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x03C)))
#define JS_204C_RX0_SUBCTRL_SYSREF_RX_SEL                   (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x040)))
#define JS_204C_RX0_SUBCTRL_SYNC_B_SEL                      (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x044)))
#define JS_204C_RX0_SUBCTRL_INTR_MASK                       (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x048)))
#define JS_204C_RX0_SUBCTRL_INTR_TH_0                       (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x04C)))
#define JS_204C_RX0_SUBCTRL_INTR_TH_1                       (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x050)))
#define JS_204C_RX0_SUBCTRL_INTR_TH_2                       (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x054)))
#define JS_204C_RX0_SUBCTRL_INTR_TH_3                       (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x058)))
#define JS_204C_RX0_SUBCTRL_SYSREF                          (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x05C)))
#define JS_204C_RX0_SUBCTRL_INTR_FLAG                       (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x060)))
#define JS_204C_RX0_SUBCTRL_SAM_ERR_CNT                     (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x064)))
#define JS_204C_RX0_SUBCTRL_TL_TEST_MODE_CNT                (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x068)))
#define JS_204C_RX0_SUBCTRL_SAM_IF_RECORD_DATA              (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x0800)))
#define JS_204C_RX0_SUBCTRL_MAP_IF_RECORD_DATA              (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x1000)))
#define JS_204C_RX0_SUBCTRL_SERDES_IF_RECORD_DATA           (*((volatile uint32_t *)(JS_204C_RX0_SUBCTRL_BASE + 0x1400)))

#define JS_204C_RX1_SUBCTRL_SH_LOCK                         (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x014)))
#define JS_204C_RX1_SUBCTRL_EMB_LOCK                        (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x018)))
#define JS_204C_RX1_SUBCTRL_RX_CMD                          (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x020)))
#define JS_204C_RX1_SUBCTRL_CMD_ERR_CNT_0                   (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x024)))
#define JS_204C_RX1_SUBCTRL_CMD_ERR_CNT_1                   (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x028)))
#define JS_204C_RX1_SUBCTRL_CMD_VALID_APB_CNT               (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x02C)))
#define JS_204C_RX1_SUBCTRL_SYSREF_CNT                      (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x030)))
#define JS_204C_RX1_SUBCTRL_SAM_IF_RECORD                   (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x034)))
#define JS_204C_RX1_SUBCTRL_MAP_IF_RECORD                   (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x038)))
#define JS_204C_RX1_SUBCTRL_SERDES_IF_RECORD                (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x03C)))
#define JS_204C_RX1_SUBCTRL_SYSREF_RX_SEL                   (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x040)))
#define JS_204C_RX1_SUBCTRL_SYNC_B_SEL                      (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x044)))
#define JS_204C_RX1_SUBCTRL_INTR_MASK                       (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x048)))
#define JS_204C_RX1_SUBCTRL_INTR_TH_0                       (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x04C)))
#define JS_204C_RX1_SUBCTRL_INTR_TH_1                       (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x050)))
#define JS_204C_RX1_SUBCTRL_INTR_TH_2                       (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x054)))
#define JS_204C_RX1_SUBCTRL_INTR_TH_3                       (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x058)))
#define JS_204C_RX1_SUBCTRL_SYSREF                          (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x05C)))
#define JS_204C_RX1_SUBCTRL_INTR_FLAG                       (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x060)))
#define JS_204C_RX1_SUBCTRL_SAM_ERR_CNT                     (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x064)))
#define JS_204C_RX1_SUBCTRL_TL_TEST_MODE_CNT                (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x068)))
#define JS_204C_RX1_SUBCTRL_SAM_IF_RECORD_DATA              (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x0800)))
#define JS_204C_RX1_SUBCTRL_MAP_IF_RECORD_DATA              (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x1000)))
#define JS_204C_RX1_SUBCTRL_SERDES_IF_RECORD_DATA           (*((volatile uint32_t *)(JS_204C_RX1_SUBCTRL_BASE + 0x1800)))

#define JS_204C_TX_SUBCTRL_SAM_IF_RECORD_EN                 (*((volatile uint32_t *)(JS_204C_TX_SUBCTRL_BASE + 0x014)))
#define JS_204C_TX_SUBCTRL_SERDES_IF_RECORD_EN              (*((volatile uint32_t *)(JS_204C_TX_SUBCTRL_BASE + 0x018)))
#define JS_204C_TX_SUBCTRL_TRANS_TH                         (*((volatile uint32_t *)(JS_204C_TX_SUBCTRL_BASE + 0x01C)))
#define JS_204C_TX_SUBCTRL_SYSREF_TX_SEL                    (*((volatile uint32_t *)(JS_204C_TX_SUBCTRL_BASE + 0x020)))
#define JS_204C_TX_SUBCTRL_SYNC_B_SEL                       (*((volatile uint32_t *)(JS_204C_TX_SUBCTRL_BASE + 0x024)))
#define JS_204C_TX_SUBCTRL_TX_CMD                           (*((volatile uint32_t *)(JS_204C_TX_SUBCTRL_BASE + 0x028)))
#define JS_204C_TX_SUBCTRL_CMD_APB_VALID_CNT                (*((volatile uint32_t *)(JS_204C_TX_SUBCTRL_BASE + 0x02C)))
#define JS_204C_TX_SUBCTRL_CMD_SENT_CNT                     (*((volatile uint32_t *)(JS_204C_TX_SUBCTRL_BASE + 0x030)))
#define JS_204C_TX_SUBCTRL_SAM_DATA_IDLE_ARRAY0             (*((volatile uint32_t *)(JS_204C_TX_SUBCTRL_BASE + 0x038)))
#define JS_204C_TX_SUBCTRL_SAM_DATA_IDLE_ARRAY1             (*((volatile uint32_t *)(JS_204C_TX_SUBCTRL_BASE + 0x03C)))
#define JS_204C_TX_SUBCTRL_SAM_DATA_IDLE_ARRAY2             (*((volatile uint32_t *)(JS_204C_TX_SUBCTRL_BASE + 0x040)))
#define JS_204C_TX_SUBCTRL_SAM_DATA_IDLE_ARRAY3             (*((volatile uint32_t *)(JS_204C_TX_SUBCTRL_BASE + 0x044)))
#define JS_204C_TX_SUBCTRL_SAM_DATA_IDLE_ARRAY4             (*((volatile uint32_t *)(JS_204C_TX_SUBCTRL_BASE + 0x048)))
#define JS_204C_TX_SUBCTRL_SAM_DATA_IDLE_ARRAY5             (*((volatile uint32_t *)(JS_204C_TX_SUBCTRL_BASE + 0x04C)))
#define JS_204C_TX_SUBCTRL_SAM_DATA_IDLE_ARRAY6             (*((volatile uint32_t *)(JS_204C_TX_SUBCTRL_BASE + 0x050)))
#define JS_204C_TX_SUBCTRL_SAM_DATA_IDLE_ARRAY7             (*((volatile uint32_t *)(JS_204C_TX_SUBCTRL_BASE + 0x054)))
#define JS_204C_TX_SUBCTRL_SAM_DATA_IDLE_CNT                (*((volatile uint32_t *)(JS_204C_TX_SUBCTRL_BASE + 0x058)))
#define JS_204C_TX_SUBCTRL_SAM_IF_RECORD_DONE               (*((volatile uint32_t *)(JS_204C_TX_SUBCTRL_BASE + 0x05C)))
#define JS_204C_TX_SUBCTRL_SERDES_IF_RECORD_DONE            (*((volatile uint32_t *)(JS_204C_TX_SUBCTRL_BASE + 0x060)))
#define JS_204C_TX_SUBCTRL_SAM_IF_RECORD_DATA               (*((volatile uint32_t *)(JS_204C_TX_SUBCTRL_BASE + 0x800)))
#define JS_204C_TX_SUBCTRL_SERDES_IF_RECORD_DATA            (*((volatile uint32_t *)(JS_204C_TX_SUBCTRL_BASE + 0x1000)))


#endif // __JESD204_H__

